#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#define PIN 3

Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);

int del = 998;

int i;
int j;
int ji;
int k;

//start time in num of neopixels from 12 o clock
int hour = 35;
int minute = 59;
int second = 0;

//light offset
int Loffset = 16;

int numPixelH;
int offsetH = Loffset + hour;
int numPixelM;
int offsetM = Loffset + minute;
int numPixelS;
int offsetS = Loffset + second;

void setup() {
  // put your setup code here, to run once:
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {
  // put your main code here, to run repeatedly:
  for (i = 60; i > 0; i = i - 5) {
    theaterChase(strip.Color(200, 0, 100), 50); // Red
    //hour in red
    numPixelH = i - offsetH;
    if (numPixelH < 0) numPixelH = 60 + numPixelH; //get to start of strip
    strip.setPixelColor(numPixelH, 255, 0, 0); //red
    if (numPixelH == 59) { //turn off prev light
      strip.setPixelColor(0, 0, 0, 0); //off
    } else {
      strip.setPixelColor(numPixelH + 1, 0, 0, 0); //off
    }
    //minutes in blue
    for (j = 60; j > 0; j--) {
      numPixelM = j - offsetM;
      if (numPixelM < 0) numPixelM = 60 + numPixelM; //when get to start of strip
      //turn on all blue from begining of hour
      if (numPixelM <= 44) {
        for (ji = 44; ji >= numPixelM; ji--) {
          strip.setPixelColor(ji, 0, 0, 255); //blue
        }
      } else if (numPixelM > 44) {
        for (ji = 44; ji >= 0; ji--) {
          strip.setPixelColor(ji, 0, 0, 255); //blue
        }
        for (ji = numPixelM; ji <= 59; ji++) {
          strip.setPixelColor(ji, 0, 0, 255); //blue
        }
      }
      if (numPixelH >= numPixelM) {
        strip.setPixelColor(numPixelH, 255, 0, 0); //when set back to hour color
      } else if (numPixelH < numPixelM && numPixelM > 44) {
        strip.setPixelColor(numPixelH, 255, 0, 0); //when set back to hour color
      } else if (numPixelM == 59 && numPixelH == 59) {
        strip.setPixelColor(numPixelM, 255, 0, 0); //when set back to hour color
      }
      //seconds in green
      for (k = 60; k > 0; k--) {
        numPixelS = k - offsetS;
        if (numPixelS < 0) numPixelS = 60 + numPixelS; //when get to start of strip
        strip.setPixelColor(numPixelS, 0, 255, 0); //green
        //turn prev light to right color
        if (numPixelS + 1 < numPixelM) {
          if (numPixelS + 1 <= 44 && numPixelM <= 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 0); //off
          } else if (numPixelS + 1 <= 44 && numPixelM > 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 255); //blue
          } else if (numPixelS + 1 > 44 && numPixelM > 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 0); //off
          }
        } else if (numPixelS + 1 > numPixelM) {
          if (numPixelS == 59 && numPixelM <= 44 && numPixelM != 0) {
            strip.setPixelColor(0, 0, 0, 0); //off
          } else if (numPixelS == 59 && numPixelM == 0) {
            strip.setPixelColor(0, 0, 0, 255); //blue
          } else if (numPixelS == 59 && numPixelM > 44) {
            strip.setPixelColor(0, 0, 0, 255); //blue
          } else if (numPixelS + 1 <= 44 && numPixelM <= 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 255); //blue
          } else if (numPixelS + 1 > 44 && numPixelM <= 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 0); //off
          } else if (numPixelS + 1 > 44 && numPixelM > 44) {
            strip.setPixelColor(numPixelS + 1, 0, 0, 255); //blue
          }
        } else if (numPixelS == 59) {
          if (numPixelM <= 44 && numPixelM != 0) {
            strip.setPixelColor(0, 0, 0, 0); //off
          } else if (numPixelM == 0) {
            strip.setPixelColor(0, 0, 0, 255); //blue
          } else if (numPixelM > 44) {
            strip.setPixelColor(0, 0, 0, 255); //blue
          }
        } else if (numPixelS + 1 == numPixelM && numPixelS != 59) {
          strip.setPixelColor(numPixelS + 1, 0, 0, 255); //blue
        }
        if (numPixelS + 1 == numPixelH) {
          strip.setPixelColor(numPixelS + 1, 255, 0, 0); //set back to hour color
        }
        strip.show();
        delay(del);
      }
      if (numPixelM == 45) {
        offsetM = 16;
        break; // change hour when minute gets to 12o clock
      }
    }

  }
}

//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) {
  for (int j = 0; j < 10; j++) { //do 10 cycles of chasing
    for (int q = 0; q < 3; q++) {
      for (uint16_t i = 0; i < strip.numPixels(); i = i + 3) {
        strip.setPixelColor(i + q, c);  //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i = 0; i < strip.numPixels(); i = i + 3) {
        strip.setPixelColor(i + q, 0);      //turn every third pixel off
      }
    }
  }
}
